import 'dart:async';

import 'package:vgk_game_services/games_services_platform_interface/method_channel_games_services.dart';
import 'package:vgk_game_services/games_services_platform_interface/models/achievement.dart';
import 'package:vgk_game_services/games_services_platform_interface/models/score.dart';

class VgkGameServices {
  static Future<String?> unlock({achievement: Achievement}) async {
    return await MethodChannelGamesServices.instance
        .unlock(achievement: achievement);
  }

  static Future<String?> increment({achievement: Achievement}) async {
    return await MethodChannelGamesServices.instance
        .increment(achievement: achievement);
  }

  static Future<String?> submitScore({score: Score}) async {
    return await MethodChannelGamesServices.instance.submitScore(score: score);
  }

  static Future<String?> showAchievements() async {
    return await MethodChannelGamesServices.instance.showAchievements();
  }

  static Future<String?> showLeaderboards(
      {iOSLeaderboardID = "", androidLeaderboardID = ""}) async {
    return await MethodChannelGamesServices.instance.showLeaderboards(
        iOSLeaderboardID: iOSLeaderboardID,
        androidLeaderboardID: androidLeaderboardID);
  }

  static Future<String?> signIn() async {
    return await MethodChannelGamesServices.instance.signIn();
  }

  static Future<bool> get isSignedIn async =>
      await MethodChannelGamesServices.instance.isSignedIn ?? false;

  static Future<String?> signOut() async {
    return await MethodChannelGamesServices.instance.signOut();
  }

  static Future<String?> hideAccessPoint() async {
    return await MethodChannelGamesServices.instance.hideAccessPoint();
  }

  static Future<String?> getPlayerID() async {
    return await MethodChannelGamesServices.instance.getPlayerID();
  }
}
